# Parsec Cloud (https://parsec.cloud) Copyright (c) BUSL-1.1 2016-present Scille SAS

# /!\ Autogenerated by misc/gen_protocol_typings.py, any modification will be lost !

from __future__ import annotations

from parsec._parsec import DateTime, InvitationToken

class Req:
    def __init__(
        self,
        ciphered_data: bytes,
        reveal_token: InvitationToken,
        shamir_recovery_brief_certificate: bytes,
        shamir_recovery_share_certificates: list[bytes],
    ) -> None: ...
    def dump(self) -> bytes: ...
    @property
    def ciphered_data(self) -> bytes: ...
    @property
    def reveal_token(self) -> InvitationToken: ...
    @property
    def shamir_recovery_brief_certificate(self) -> bytes: ...
    @property
    def shamir_recovery_share_certificates(self) -> list[bytes]: ...

class Rep:
    @staticmethod
    def load(raw: bytes) -> Rep: ...
    def dump(self) -> bytes: ...

class RepUnknownStatus(Rep):
    def __init__(self, status: str, reason: str | None) -> None: ...
    @property
    def status(self) -> str: ...
    @property
    def reason(self) -> str | None: ...

class RepOk(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepInvalidCertificateBriefCorrupted(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepInvalidCertificateShareCorrupted(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepInvalidCertificateShareRecipientNotInBrief(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepInvalidCertificateDuplicateShareForRecipient(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepInvalidCertificateAuthorIncludedAsRecipient(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepInvalidCertificateMissingShareForRecipient(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepInvalidCertificateShareInconsistentTimestamp(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepInvalidCertificateUserIdMustBeSelf(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepRecipientNotFound(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepRevokedRecipient(Rep):
    def __init__(self, last_common_certificate_timestamp: DateTime) -> None: ...
    @property
    def last_common_certificate_timestamp(self) -> DateTime: ...

class RepShamirRecoveryAlreadyExists(Rep):
    def __init__(self, last_shamir_certificate_timestamp: DateTime) -> None: ...
    @property
    def last_shamir_certificate_timestamp(self) -> DateTime: ...

class RepTimestampOutOfBallpark(Rep):
    def __init__(
        self,
        ballpark_client_early_offset: float,
        ballpark_client_late_offset: float,
        server_timestamp: DateTime,
        client_timestamp: DateTime,
    ) -> None: ...
    @property
    def ballpark_client_early_offset(self) -> float: ...
    @property
    def ballpark_client_late_offset(self) -> float: ...
    @property
    def client_timestamp(self) -> DateTime: ...
    @property
    def server_timestamp(self) -> DateTime: ...

class RepRequireGreaterTimestamp(Rep):
    def __init__(self, strictly_greater_than: DateTime) -> None: ...
    @property
    def strictly_greater_than(self) -> DateTime: ...
